	section 	draw_led
	xdef		draw_led

	xref		chan_num
	include 	dev8_keys_err
	include 	dev8_keys_qdos_io
	include 	dev8_keys_qlv
	include 	dev8_keys_sbasic

**********************************************************************
*	draw_led	[#chan%],col,how_many_figures,value$
*
*	draws the value$ as a led figure
*	value$ may only contain: numbers from 0-9, minus sign (-),decimal point (.)
*
*	v. 1.06 	totally new version, draws nicer figures
**********************************************************************


xsize	equ	0
ysize	equ	xsize+2 		; x,y orig (of wdw, or block)
xorig	equ	ysize+2 		; same for origin
yorig	equ	xorig+2
col1	equ	yorig+2
col2	equ	col1+4
stipple equ	col2+4
mystack equ	stipple+4


draw_block  macro
	lea	col1(a1),a2
	move.l	d2,d1			; colour
	move.l	d7,d0			; what trap do we use?
	trap	#3			; draw blk
	lea	4(a7),a1
	endm
    
draw_blk2  macro
	lea	col1(a1),a2
	move.l	d2,d1			; colour
	move.l	d7,d0			; what trap do we use?
	trap	#3			; draw blk
	lea	8(a7),a1
	endm

draw_led
	move.b	$bd(a6),d7		; what colour mode are we in?
	bne.s	no_ql
	moveq	#iow.blok,d7		; block drawing trap call if ql mode
	bra.s	col_all
no_ql	sub.w	#$50,d7 		; is it pal?
	bne.s	no_pal			; no
	moveq	#iow.blkp,d7		; block drawing trap call if pal mode
	bra.s	col_all
no_pal	subq.w	#4,d7			; is it 24 colour?
	bne.s	no_24			; no->...
	moveq	#iow.blkt,d7		; block drawing trap call if 24bit mode
	bra.s	col_all
no_24	moveq	#iow.blkn,d7		; block drawing trap call if native mode
col_all bsr	chan_num		; get the channel into a0
	bne	dled_out		; ooops!
	move.l	a0,a4			; keep
	moveq	#iow.clra,d0
	moveq	#-1,d3
	trap	#3			; clear wdw
	move.l	sb_arthp(a6),a1
	lea	16(a3),a5
	move.w	sb.gtlin,a2
	jsr	(a2)			; get the 2 longs (col, how many figures)
	bne	dled_out
	sub.w	#2,d3			; only	2
	bne	bp_err
	addq.l	#8,sb_arthp(a6) 	; reset maths stack
	move.l	(a6,a1.l),d2		; d2 = col for channel
	cmp.w	#$5d,d7 		; 24 bit mode?
	bne.s	no_scr			; no->...
	lsl.l	#8,d2			; yes, make compatible
no_scr	move.l	4(a6,a1.l),d5		; d5.W = how many figures
	move.l	sb_arthp(a6),a1
	move.l	a5,a3
	addq.l	#8,a5
	movem.l d2/d5,-(a7)
	move.w	sb.gtstr,a2
	jsr	(a2)			; get the string
	movem.l (a7)+,d2/d5
	bne	dled_out
	subq.w	#1,d3			; only one, please
	bne	bp_err
	move.w	(a6,a1.l),d0		; length of string
	beq	bp_err			; there is none!
	addq.w	#3,d0
	bclr	#0,d0
	add.l	d0,sb_arthp(a6) 	; reset maths stack
	moveq	#-1,d3
	move.l	a1,a4			; A4 = point to string, rel a6


; as of here
; D2 =	colour
; D3 =	timeout
; d5 =	how many figures
; D7 =	colour trap code
; A4 =	string to display (rel to A6)

intrl	sub.l	#mystack,a7
	move.l	a7,a1			; get some space
	moveq	#iow.xtop,d0
	lea	xtop,a2
	trap	#3			; get size & orig of chan into (a1)
	tst.l	d0			; any error?
	bne	dledout4		; yes, but return w/o error! ->...
	moveq	#0,d6
	move.w	xsize(a1),d6		; x size of wdw
	move.w	(a6,a4.l),d0		; length of string
	subq.w	#1,d0
	lea	2(a4),a3		; point to string content
	moveq	#0,d4
ct_rep	move.b	(a6,a3.l),d1
	sub.b	#'-',d1 		; is it a minus sign ?
	bne.s	no_min			;   ... no
	move.b	#10*8,(a6,a3.l) 	; yes, show it
	bra.s	ct_lp
no_min	subq.b	#1,d1			; is it decimal point?
	bne.s	no_decpt		;   ...no
	tst.b	d4			;   ... yes, but was there one already?
	bmi	dledout3		;     ... yes, so error
	moveq	#-6,d4			; signal presence of decimal
	move.b	d4,(a6,a3.l)		; signal decimal point
	bra.s	ct_lp			; and continue
no_decpt
	subq.b	#2,d1
	bmi	dledout3		; this is not an acceptable character
	cmp.b	#9,d1
	bgt	dledout3		; nor this
	lsl.b	#3,d1			; 8 byte table
	move.b	d1,(a6,a3.l)
ct_lp	addq.l	#1,a3
	dbf	d0,ct_rep
; as of here, that data is checked and is an index into my table
;
; D2 = colour
; D3 = timeout
; d4 = possible space needed for decimal point
; d5 = how many figures to display
; d7 = colour mode (trap code!)
; A4 = pointer to my data = "characters"
; a1 (a7) = pointer to some heap space
	moveq	#0,d6
	move.w	xsize(a1),d6		; x size of wdw
	add.w	d4,d6			; space for decimal point (d4 is negative)
	bmi	dledout6		; wdw too small->...
offs_all
	divu	d5,d6			; x size for one element = x spacing
	swap	d6
	lsr.w	#1,d6			; offset from edges of wdw
	swap	d6			; offset | x spacing
	move.w	d6,d4			; xspacing
	beq	dledout6		; none?????
	subq.w	#2,d4
	ble	dledout6		; window is just too small!
	lsr.w	#2,d4			; current segment thickness
	move.w	ysize(a1),d1		; ysize of wdw
	subq.w	#2,d1			; leave 1 pixel border at each end
	divs	#7,d1			; make another current thickness
	cmp.w	d4,d1			; use the thinner of both thicknesses
	bge.s	no_xchg
	move.w	d1,d4
no_xchg btst	#0,d4			; thickness must be uneven nbr
	bne.s	uneven			; it already is
	subq.w	#1,d4
uneven	tst.w	d4
	ble	dledout6		; line thickness is way too small
	move.w	d6,d0			; x spacing
	subq.w	#8,d0			; max length of 1 horizontal segment
	ble	dledout6		; wdw is too small
	swap	d0
	move.w	ysize(a1),d0		; y size of wdw
	subq.w	#5,d0			; minus borders & gap
	lsr.w	#1,d0			; there are 2 of them - max hight of vertical segment
	beq	dledout6		; there must be at least 1 pixle
	move.l	d0,a5			; xsize%,ysize%

; D2 = colour
; D3 = timeout
; d4 = segment thickness in pixels
; d5 = how many figures to display
; d6 = offset | x spacing
; d7 = colour mode (trap code!)
; a1 (a7) = pointer to some heap space
; A4 = pointer to my data = "characters"
; A5 = xsize | ysize (max sizes of hor & vert segments)
;
	clr.l	d0			; now make x origin of 1rst char (end of wdw)
	move.w	xsize(a1),d0		; xsize
	addq.w	#2,d0			; point after end of window
	swap	d6
	sub.w	d6,d0			; minus offet from start
	swap	d6
	swap	d0			; xorig | ????
	move.w	#1,d0			; y orig
	move.l	d0,d1			; xorigin | yorigin
	moveq	#1,d5
	add.w	(a6,a4.l),d5		; length of string -1
	add.w	d5,a4			; point to last char
	subq.w	#2,d5			; minus length word & prepare for dbf
	move.l	a7,a1
	lea	col1(a1),a2
	move.l	d2,(a2)
	move.l	d2,4(a2)
	move.l	#-1,8(a2)
	swap	d5
	move.w	d4,d5
	subq.w	#1,d5
	swap	d5

; D0 = <var>
; D1 = xorigin | yorigin
; D2 = colour
; D3 = timeout
; d4 = segment thickness in pixels
; d5 = segment thickness in pixels -1| how many chars to display (big loop counter)
; d6 = offset | x spacing
; d7 = colour mode (trap code!)
; a0 = channel ID
; a1 = pointer to block definition
; A2 = var (used in trap)
; A4 = pointer to my data = "characters"
; A5 = xsize | ysize (max sizes of hor & vert segments)
;
; loop for each char in string
	move.l	d1,-(a7)
bg_lp	swap	d5			; d5 = big loop counter | segment thickness
	lea	table,a3		; point to start of table
	clr.l	d0
	move.b	(a6,a4.l),d0		; get character
	bmi	decpt			; its a decimal point!!!
	add.l	d0,a3
; now first the three horizontal segments
	move.l	(a7),d0
	swap	d0
	sub.w	d6,d0			; new x origin
	swap	d0
	move.l	d0,xorig(a1)		; set it
	move.l	d0,(a7)
	move.w	#1,ysize(a1)		; set y size of block
	move.l	a5,d0
	swap	d0
	move.l	d0,a5			; a5 = y size, x size
	move.w	a5,xsize(a1)		; size of block
; treat upper segment
v_upp	move.b	(a3)+,d0		; paint this segment?
	beq.s	v_mid			; ...no
	move.w	d5,d4			; counter
	add.w	#2,xorig(a1)
vupp_lp
	draw_block
	sub.w	#2,xsize(a1)
	add.l	#$10001,xorig(a1)
	dbf	d4,vupp_lp
	move.l	(a7),xorig(a1)		; reset origins
	move.w	a5,xsize(a1)		; reset line width

; middle segment
v_mid	move.b	(a3)+,d0		; treat this segment?
	beq.s	v_low			; now
	move.w	d5,d4			; half line counter
	lsr.w	#1,d4
	add.w	d4,xorig(a1)
	add.w	#2,xorig(a1)
	move.w	d4,d0
	lsl.w	#1,d0
	sub.w	d0,xsize(a1)
	move.l	a5,d0			; ysize | xsize
	swap	d0			; ysize
	addq.w	#2,d0			; make y orig
	sub.w	d4,d0
	move.w	d0,yorig(a1)
	subq.w	#1,d4
	blt.s	no_tmp1
vmidlp1
	draw_block
	sub.w	#1,xorig(a1)		; start one more to the left
	add.w	#2,xsize(a1)		; make line 2 pixels longer
	add.w	#1,yorig(a1)		; start one line down
	dbf	d4,vmidlp1
no_tmp1
	draw_block
	move.w	d5,d4			; half line counter
	lsr.w	#1,d4
	subq.w	#1,d4
	blt.s	no_tmp2
vmidlp2 sub.w	#2,xsize(a1)
	add.l	#$10001,xorig(a1)
	draw_block
	dbf	d4,vmidlp2
no_tmp2 move.l	(a7),xorig(a1)		; reset origins
	move.w	a5,xsize(a1)		; reset line width
; now treat lower segment

v_low	move.b	(a3)+,d0		; treat this segment?
	beq.s	h_up_l			; no
	move.l	a5,d0			; ysize | xsize
	move.w	#2,d0			; usize | 2
	swap	d0			; 2 | ysize
	add.w	d0,d0			; 2 | ysize *2
	addq.w	#2,d0
	add.l	d0,xorig(a1)		; set new origins
	move.w	d5,d4
vlow_lp
	draw_block
	sub.w	#2,xsize(a1)		; make new length
	add.w	#1,xorig(a1)		; move one to the right
	sub.w	#1,yorig(a1)		; and one up
	dbf	d4,vlow_lp		; for all rows
vl_end	move.l	(a7),xorig(a1)		; reset origins
	move.w	a5,xsize(a1)		; reset line width

; treat upper left segment
h_up_l
	move.l	a5,d0
	swap	d0			; xsize | ysize
	move.l	d0,a5
	move.w	#1,xsize(a1)		; block x size will now be 1
	move.w	a5,ysize(a1)		; preset size
	move.b	(a3)+,d0
	beq.s	h_low_l
	add.w	#1,yorig(a1)
	bsr.s	horizl
	move.l	(a7),xorig(a1)
	move.w	a5,ysize(a1)
h_low_l
	move.b	(a3)+,d0
	beq.s	h_up_r
	moveq	#2,d0
	add.w	a5,d0
	add.w	d0,yorig(a1)
	bsr.s	horizl
	move.l	(a7),xorig(a1)
	move.w	a5,ysize(a1)
h_up_r
	move.b	(a3)+,d0
	beq.s	h_low_r
	add.w	#1,yorig(a1)
	bsr.s	horizr
	move.l	(a7),xorig(a1)
	move.w	a5,ysize(a1)
h_low_r
	move.b	(a3)+,d0
	beq.s	next_c
	moveq	#2,d0
	add.w	a5,d0
	add.w	d0,yorig(a1)
	bsr.s	horizr
	move.l	(a7),xorig(a1)
	move.w	a5,ysize(a1)

next_c	subq.l	#1,a4			; point previous character now
	swap	d5
	dbf	d5,bg_lp
	moveq	#0,d0
	addq.l	#4,a7
	bra	dledout2


horizl	move.w	d5,d4
hor_lp1
	draw_blk2
	sub.w	#2,ysize(a1)
	add.l	#$10001,xorig(a1)
	dbf	d4,hor_lp1
	rts

horizr	move.w	d5,d4
	add.w	d6,xorig(a1)
	sub.w	#5,xorig(a1)
hor_lp2
	draw_blk2
	sub.w	#1,xorig(a1)
	add.w	#1,yorig(a1)
	sub.w	#2,ysize(a1)
	dbf	d4,hor_lp2
	rts

; do decimal point
decpt
	move.w	(a7),d1 		; xorig
	subq.w	#6,d1
	move.w	d1,(a7)
	addq.w	#1,d1
	move.w	d1,xorig(a1)
	move.w	a5,d0			; ysize
	add.w	d0,d0			; *2
	add.w	d0,yorig(a1)
	move.l	#$20002,xsize(a1)	; make sizes
	draw_block
	move.l	(a7),xorig(a1)
	move.l	a5,xsize(a1)
	bra	next_c


dledout6
	moveq	#err.orng,d0
	bra.s	dledout2
dledout3
	moveq	#-15,d0
dledout2
	add.l	#mystack,a7
dled_out
	rts
dledout4
	moveq	#0,d0
	bra.s	dledout2

bp_err	moveq	#-15,d0
	rts

xtop	move.l	$1c(a0),(a1)	; size
	move.l	$18(a0),4(a1)	; orig
	moveq	#0,d0
	rts
 

table	dc.b 1,0,1,1,1,1,1,0  : rem  0
	dc.b 0,0,0,0,0,1,1,0  : rem  1
	dc.b 1,1,1,0,1,1,0,0
	dc.b 1,1,1,0,0,1,1,0  : rem  3
	dc.b 0,1,0,1,0,1,1,0  : rem  4
	dc.b 1,1,1,1,0,0,1,0
	dc.b 0,1,1,1,1,0,1,0
	dc.b 1,0,0,0,0,1,1,0
	dc.b 1,1,1,1,1,1,1,0  : rem  8
	dc.b 1,1,0,1,0,1,1,0
	dc.b 0,1,0,0,0,0,0,0  : rem  minus sign (-)


	end

this is the translation of the following basic prog

DEFine PROCedure drawled(chan%,col,fig%,number$)
LOCal xsize%,ysisze%,temp%,xo%,yo%,count%,lp%,sizes%(3),xspg%,yspg%
LOCal lnbr%
  WSIZE#chan%,sizes%
  CLS#chan%
  count%=LEN(number$)
  IF NOT count%:RETurn			   : REMark no number ?
  temp%=0				: REMark no additional space for '.' yet
  FOR lp%=1 TO count%
    IF NOT number$(lp%) INSTR '.-0123456789':RETurn
    IF number$(lp%) INSTR '.':temp%=6	: REMark additional space for '.'
  END FOR lp%
  xspg%=(sizes%(0)-temp%) DIV fig%	: REMark xspacing
  xoff%= (sizes%(0) MOD fig% ) DIV 2
  lnbr%=(xspg%-2) DIV 4 		: REMark current max segment width
  temp%=(sizes%(1)-2) DIV 7		: REMark
  IF temp%<lnbr%:lnbr%=temp%
  IF NOT (lnbr% && 1):lnbr%=lnbr%-1	: REMark make uneven
 REMark IF lnbr%>9:lnbr%=9		      : REMark max line thickness
  IF lnbr%<1:RETurn
  xsize%=xspg%-6			: REMark max line width
  ysize%=(sizes%(1)-5) DIV 2		: REMark max line height
  xo%=sizes%(0)+1-xoff%
  yo%=1
  FOR lp%=count% TO 1 STEP -1
    xo%=xo%-xspg%
    IF number$(lp%)<>'.'
      IF number$(lp%)='-'
	t%=10
      ELSE
	t%=number$(lp%)
      END IF
    ELSE
       xo%=xo%+xspg%-6
       BLOCK#chan%,2,2,xo%+1,yo%+2*ysize%,col
       NEXT lp%
    END IF
    IF figures%(t%,0):v_upper
    IF figures%(t%,1):v_middle
    IF figures%(t%,2):v_lower
    IF figures%(t%,3):h_left yo%+1
    IF figures%(t%,4):h_left yo%+2+ysize%
    IF figures%(t%,5):h_right yo%+1
    IF figures%(t%,6):h_right yo%+2+ysize%
  END FOR lp%
END DEFine drawled
:
DEFine PROCedure v_upper
LOCal x%,y%,xs%,lp%
  x%=xo%+2
  y%=yo%
  xs%=xsize%
  FOR lp%=1 TO lnbr%
    BLOCK#chan%,xs%,1,x%,y%,col
    xs%=xs%-2
    x%=x%+1
    y%=y%+1
  END FOR lp%
END DEFine v_upper
:
DEFine PROCedure v_middle
LOCal x%,y%,xs%,lp%,temp%
  temp%=lnbr% DIV 2
  x%=xo%+2+temp%
  xs%=xsize%-(temp%*2)
  y%=yo%+1+ysize%-temp%
  IF temp%
    FOR lp%=1 TO temp%
      BLOCK#chan%,xs%,1,x%,y%,col
      xs%=xs%+2
      x%=x%-1
      y%=y%+1
    END FOR lp%
  END IF
  BLOCK#chan%,xs%,1,x%,y%,col
  IF temp%
    FOR lp%=1 TO temp%
      xs%=xs%-2
      x%=x%+1
      y%=y%+1
      BLOCK#chan%,xs%,1,x%,y%,col
    END FOR lp%
  END IF
END DEFine v_middle
:
DEFine PROCedure v_lower
LOCal x%,y%,xs%,lp%
  x%=xo%+2
  y%=yo%+2+2*ysize%
  xs%=xsize%
  FOR lp%=1 TO lnbr%
    BLOCK#chan%,xs%,1,x%,y%,col
    xs%=xs%-2
    x%=x%+1
    y%=y%-1
  END FOR lp%
END DEFine v_lower
:
DEFine PROCedure h_left (yoo%)
LOCal ys%,x%,lp%,y%
  ys%=ysize%
  x%=xo%
  y%=yoo%
  FOR lp%=1 TO lnbr%
    BLOCK#chan%,1,ys%,x%,y%,col
    ys%=ys%-2
    x%=x%+1
    y%=y%+1
  END FOR lp%
END DEFine h_left
:
DEFine PROCedure h_right (yoo%)
LOCal ys%,x%,lp%,y%
  ys%=ysize%
  x%=xo%+xspg%-3
  y%=yoo%
  FOR lp%=1 TO lnbr%
    BLOCK#chan%,1,ys%,x%,y%,col
    ys%=ys%-2
    x%=x%-1
    y%=y%+1
  END FOR lp%
END DEFine h_right
:
DEFine PROCedure make_figures
LOCal lp1%,lp2%
  RESTORE
  DIM figures%(10,7)
  FOR lp1%=0 TO 10
    FOR lp2%=0 TO 7
      READ figures%(lp1%,lp2%)
    END FOR lp2%
  END FOR lp1%
  DATA 1,0,1,1,1,1,1,0	: REMark  0
  DATA 0,0,0,0,0,1,1,0	: REMark  1
  DATA 1,1,1,0,1,1,0,0
  DATA 1,1,1,0,0,1,1,0	: REMark  3
  DATA 0,1,0,1,0,1,1,0	: REMark  4
  DATA 1,1,1,1,0,0,1,0
  DATA 0,1,1,1,1,0,1,0
  DATA 1,0,0,0,0,1,1,0
  DATA 1,1,1,1,1,1,1,0	: REMark  8
  DATA 1,1,0,1,0,1,1,0
  DATA 0,1,0,0,0,0,0,0	: REMark  minus sign (-)
END DEFine make_figures
:
