	section	none

; this is panning with Long words

; parameters set up with setup_scr
	xdef	lleft
	xdef	lright
	xdef	lup
	xdef	ldown
		

; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%


; here, we do a left pan
lleft	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat
	CLR.L	D0
	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to x,y origin of "wdw" now

	MULU	D3,D5		; nbr of bytes needed for storage (step)
	MOVE.L	D5,D1		; keep
  

	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	SUBQ.W	#1,D7		; and prepare for DBF already

	CLR.W	D6
	SWAP	D6		; xsize% = nbr of pixels in "wdw"
	MULU	D3,D6		; nbr of bytes now
	SUB.W	D5,D6		; - step%
	LSR.W	#2,D6		; Lword sized moves
	SUBQ.W	#1,D6		; prepare for DBF

	LSR.W	#2,D5		; nbr of Lwords in step
	SUBQ.W	#1,D5		; prepare for DBF
; here:
; D3 = nbr of bytes / pixel
; D4 = length of 1 line, in bytes
; D5 = nbr of words for storage -1
; D6 = nbr of words to shift -1
; D7 = nbr of lines to treat -1
	MOVE.L	A0,D3		; do we need to get mem?
	BNE.S	no_mem		; no ->...
	MOVEQ	#-1,D2		; it's for myself
	ADDQ.L	#8,D1		; just to make sure we won't overlap
get_mem	MOVEQ	#$18,D0		; MT_ALCHP
	TRAP	#$1		; get memory now
	TST.L	D0		; ok?
	BNE.S	pan_out		; NO! ->...
	CLR.L	D3
no_mem	MOVE.L	A5,A3		: point to first line now

; now deal with one line, A5 points to the 1rst byte of this line
line_lp	MOVE.W	D5,D0		; nbr of words -1 for mem buffer
	MOVE.L	A0,A1		; pointer to buffer
	MOVE.L	A3,A5
	MOVE.L	A5,A2		; keep pointer to start of line
cp1_lp	MOVE.L	(A5)+,(A1)+	; copy bytes to buffer
cp1_lp_do DBF	D0,cp1_lp
; here now, A5 points to the first pixel that must be panned LEFT
; when panning LEFT, the following bytes must be copied to here
	MOVE.W	D6,D0
cp2_lp	MOVE.L	(A5)+,(A2)+	; copy bytes, thus panning left
	DBF	D0,cp2_lp 	; at the end, A5 = start of next line!
	MOVE.L	A0,A1		; point to buffer
	MOVE.W	D5,D0		; nbr of words to copy

cp3_lp	MOVE.L	(A1)+,(A2)+
	DBF	D0,cp3_lp 	; copy buf frm start of line to end of line
	ADD.L	D4,A3		: point to next line
	DBF	D7,line_lp	; do for every line
	TST.L	D3
	BEQ.S	relmem
	MOVEQ	#0,D0
	RTS
relmem	MOVEQ	#$19,D0		; release mem now
	TRAP	#1
pan_out	RTS

pan_errbp MOVEQ	#-15,D0
	RTS
; pan right
; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%


lright	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	SUBQ.W	#1,D7		; and prepare for DBF already
				         
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat
	CLR.L	D0
	MOVE.W	D6,D0		; xsize%
	SWAP	D6		; xsize% | xorig%
	ADD.W	D6,D0		; xorig% + xsize%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to pixel in "wdw" now

; calculate the nbr of bytes to shift in each line
	SWAP	D6
	SUB.W	D5,D6		; xsize%-step%
	MULU	D3,D6		; xsize%-step% in bytes
	LSR.W	#2,D6		; xsize%-step% in Lwords
	SUBQ.W	#1,D6		; prepare for DBF

; calculate the step in bytes, (size of buffer needed)
	MULU	D3,D5		; nbr of bytes needed for storage (step)
	MOVE.L	D5,D1		; keep, also memory needed
	LSR.W	#2,D5		; step in Lwords
	SUBQ.W	#1,D5		; for DBF
	MOVE.L	A0,D3
	BNE.S	liner_lp
; get mem for buffer
	ADDQ.L	#8,D1
	MOVEQ	#-1,D2		; it's for myself
	ADDQ.L	#8,D1		; just to make sure we won't overlap
	MOVEQ	#$18,D0		; MT_ALCHP
	TRAP	#$1		; get memory now
	TST.L	D0		; ok?
	BNE.S	pan_out		; NO! ->...
	CLR.L	D3
; now do each line
liner_lp	MOVE.L	A5,A2		; point to end of line
	MOVE.L	A0,A1		; point to start of buffer
	MOVE.W	D5,D0		; nbr of words in buffer
cp4_lp	MOVE.L	-(A2),(A1)+
	DBF	D0,cp4_lp 	; copy into buffer
	MOVE.L	A5,A1		; point end of line
	MOVE.W	D6,D0		; nbr of words to shift
cp5_lp	MOVE.L	-(A2),-(A1)
	DBF	D0,cp5_lp 	; copy rest of line
	MOVE.L	A0,A2		; point to buffer
	MOVE.W	D5,D0		; nbr of words in buffer
cp6_lp	MOVE.L	(A2)+,-(A1)
	DBF	D0,cp6_lp 	; get bytes back from buffer
	ADD.L	D4,A5		; point to (end of) next line
	DBF	D7,liner_lp	; do it for all lines
	TST.L	D3
	BEQ.S	relmem2
	MOVEQ	#0,D0
	RTS
relmem2	MOVEQ	#$19,D0		; release mem
	TRAP	#1
right_out RTS

; here we move up
; step% =nr of lines to scroll 32
; orig = X pixel where we start to scroll 100
; size% = nbr of X pixels to scroll 16

; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

lup	MOVE.L	A0,D2		; any mem there?
	BNE.S	nomem3
	MOVE.W	D5,D1		; step% = nbr of lines to scroll
	MULU	D6,D1		; * nbr of pixels to treat per line
	MULU	D3,D1		; nbr of bytes to store
	MOVE.L	D3,-(A7)
	ADDQ.L	#8,D1		; safety net
	MOVEQ	#$18,D0
	TRAP	#1		; get mem for this now
	MOVE.L	(A7)+,D3
	TST.L	D0
	BNE.S	right_out
	CLR.L	D2
nomem3	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	SUB.W	D5,D7		; minus step
	SUBQ.W	#1,D7		; and prepare for DBF already
				         
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat
	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to 1rst pixel in "wdw" now

	MOVE.L	A5,A3		; keep pointer to 1rst pixel of 1rst line
	SUBQ.W	#1,D5		; line counter
	SWAP	D6
	MULU	D3,D6		; nbr of bytes to treat per line
	LSR.W	#2,D6
	SUBQ.W	#1,D6		; pixel (Lword) counter
	MOVE.L	A0,A1		; point to buffer
	MOVE.W	D5,D3
line_lp1	MOVE.W	D6,D0
	MOVE.L	A3,A2
pix_lp	MOVE.L	(A2)+,(A1)+
	DBF	D0,pix_lp 	; copy bytes for 1 line
	ADD.L	D4,A3		; point to next line
	DBF	D3,line_lp1	; and do for all lines


; A3 now points to 1rst source , A5 to first target
line_lp2	MOVE.L	A5,A2		; point to target
	MOVE.L	A3,A1		; point to source
	MOVE.W	D6,D0		; nbr of words to copy per line -1
pix_lp2	MOVE.L	(A1)+,(A2)+
	DBF	D0,pix_lp2	; copy one line
	ADD.W	D4,A5		; point next target
	ADD.W	D4,A3		; point to next source
	DBF	D7,line_lp2	; at end, A5 = 1rst line to restore buffer to
	MOVE.L	A0,A1		; point to buffer
line_lp3	MOVE.W	D6,D0		; nbr of bytes to copy per line
	MOVE.L	A5,A2		; point to target
pix_lp3	MOVE.L	(A1)+,(A2)+
	DBF	D0,pix_lp3	; copy bytes for 1 line
	ADD.L	D4,A5		; point next line
	DBF	D5,line_lp3	; do for all lines
	TST.L	D2
	BEQ.S	up_out
	MOVEQ	#0,D0
	RTS
up_out	MOVEQ	#$19,D0
	TRAP	#1
up_o	RTS

; here a possible DOWN

; here we move down
; step% =nr of lines to scroll 32

; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

ldown	MOVE.L	A0,D2		; any mem there?
	BNE.S	nomem4
	MOVE.W	D5,D1		; step% = nbr of lines to scroll
	MULU	D6,D1		; * nbr of pixels to treat per line
	MULU	D3,D1		; nbr of bytes to store
	MOVE.L	D3,-(A7)
	ADDQ.L	#8,D1		; safety net
	MOVEQ	#$18,D0
	TRAP	#1		; get mem for this now
	MOVE.L	(A7)+,D3
	TST.L	D0
	BNE.S	up_o
	CLR.L	D2
nomem4	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	ADD.W	D7,D0		; yorig%+ysize%
	SUB.W	D5,D7		; minus step
	SUBQ.W	#1,D7		; and prepare for DBF already

	SUB.W	D5,D0		, yorg%+ysize%-step%=1rst line to treat
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat

	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to 1rst pixel in 1rst line now

	MOVE.L	A5,A3		; keep pointer to 1rst pixel of 1rst line
	SUBQ.W	#1,D5		; line counter
	MOVE.W	D5,D1
	SWAP	D6
	MULU	D3,D6		; nbr of bytes to treat per line
	LSR.W	#2,D6
	SUBQ.W	#1,D6		; pixel (word) counter
	MOVE.L	A0,A1		; point to buffer
	MOVE.W	D5,D3
line_lp6	MOVE.W	D6,D0
	MOVE.L	A3,A2
pix_lp4	MOVE.L	(A2)+,(A1)+
	DBF	D0,pix_lp4	; copy bytes for 1 line
	ADD.L	D4,A3		; point to next line
	DBF	D3,line_lp6	; and do for all lines


; A3 now points to 1 line after 1rst target , A5 to 1 line after first source
	SUB.L	D4,A3
	SUB.L	D4,A5
line_lp5	MOVE.L	A3,A2		; point to target
	MOVE.L	A5,A1		; point to source
	MOVE.W	D6,D0		; nbr of words to copy per line -1
pix_lp5	MOVE.L	(A1)+,(A2)+
	DBF	D0,pix_lp5	; copy one line
	SUB.L	D4,A5		; point next target
	SUB.L	D4,A3		; point to next source
	DBF	D7,line_lp5	; at end, A5 = 1rst line to restore buffer to
	MULU	D4,D1
	SUB.L	D1,A3
	MOVE.L	A0,A1		; point to buffer
line_lp4	MOVE.W	D6,D0		; nbr of bytes to copy per line
	MOVE.L	A3,A2		; point to target
pix_lp6	MOVE.L	(A1)+,(A2)+
	DBF	D0,pix_lp6	; copy bytes for 1 line
	ADD.L	D4,A3		; point next line
	DBF	D5,line_lp4	; do for all lines
	TST.L	D2
	BEQ.S	down_out
	MOVEQ	#0,D0
	RTS
down_out	MOVEQ	#$19,D0
	TRAP	#1
	RTS
	end
