
******************************************************
* this rolls/pans/scrolls part of the screen
*
* NPAN_S step%, xorig%,xsize%, yorig%,ysize%,direction% [,buffer [,fill_in]]
*
* where
*	step% = nbr of pixels to pan
*	xorig% = pixel to start at (from 0 to end of screen/line)
*	xsize% = nbr pixels to pan
*	yorig%,ysize% : same
*	direction% = roll/pan in what direction?
*		0 = left
*		1 = right
*		2 = up
*		3 = down
*	some memory to work with, or 0
*	fill_in = from where do you fill in the section if pan/scroll
*	  and not a roll?		NYI
*
*
* (c) W. Lenerz 2002
*
* v. 1.01 2002 Mar 03 09:25:54
******************************************************

	Section	npan_s
	xdef	npan_s

; parameters set up with setup_scr
	xref	scr_base		; base address of screen
	xref	scr_xsize 	; nbr of pixels (X)
	xref	scr_ysize
	xref	scr_llen		; length of 1 line in bytes
	xref	scr_bytes 	; nbr of bytes per pixel

	xref	lleft
	xref	lright
	xref	lup
	xref	ldown
		
	xref	bleft
	xref	bright
	xref	bup
	xref	bdown

no_down	MOVEQ	#-19,D0		; not implemented (yet!)
	RTS
pan_errbp MOVEQ	#-15,D0
pan_out2	RTS
NPAN_S	MOVE.W	$118,A2
	JSR	(A2)		; get long integers
	TST.L	D0
	BNE	pan_out		; oops->...
	SUB.L	A0,A0		; show no mem parameter yet
	CMP.W	#8,D3		; all parameters?
	BNE.S	pan_get7		; no!->...
	MOVE.L	28(A6,A1.L),A4	; fill_in
	ADDQ.L	#4,$58(A6)
pan_get7	CMP.W	#7,D3
	BNE.S	pan_get6
	MOVE.L	24(A6,A1.L),A0	; buffer
	ADD.L	#28,$58(A6)
	BRA.S	got_valid
pan_get6	CMP.W	#6,D3		; all parameters?
	BNE.S	pan_errbp 	; no, so error! ->...
	ADD.L	#6*4,$58(A6)	; reset maths stack
got_valid CLR.L	D3
	CLR.L	D4
	CLR.L	D5
	MOVE.L	(A6,A1.L),D5	; step%
	BEQ.S	pan_out2		; there is none, so we're finished (?)!
	MOVE.L	6(A6,A1.L),D6	; orig% into upper word
	MOVE.W	10(A6,A1.L),D6	; size% into lower wrd: xorig% | xsize%
	BEQ.S	pan_out2		; 0 size%? - we've finished ->...
	MOVE.L	14(A6,A1.L),D7	;
	MOVE.W	18(A6,A1.L),D7	; yorig% | ysize%
	BEQ.S	pan_out2		; oops! no y size?
	MOVE.L	scr_base(PC),A5	; screen base
	MOVE.W	scr_llen(PC),D4	; length of 1 line in bytes
	MOVE.W	scr_bytes(PC),D3	; nbr of bytes per pixel
	BEQ.S	pan_errbp 	; HUH?->...
	MOVE.L	20(A6,A1.L),D2	; direction switch
	BMI.S	pan_errbp
	CMP.W	#4,D2
	BGE.S	no_down		; only allow 0 to 3
	LEA	ltable,A2 	; point to long words table
	CMP.W	#4,D3		; do we use 4 bytes / pixel?
	BEQ.S	calc_jump 	; yes, use this table directly
	cmp.W	#2,D3		; 2 or 1 byte/pixel?
	BNE.S	one_byte
; here we use 2 bytes/pixel - let's see whether we still can use Lword shifts
; we can do that if the xsize% and xstep% are even
two_bytes LEA	wtable,A2 	; preset word table
	CMP.B	#1,D2		; there is no need to check the step...
	BGT.S	no_step		; ... size if we're panning vertically
	MOVE.W	D5,D0		; step%
	BTST	#0,D0		; is this even?
	BNE.S	calc_jump 	; no ->...
no_step	BTST	#0,D6		; is xsize divisible by 2?
	BNE.S	calc_jump 	; no!->...
	LEA	ltable,A2 	; here we can use long word table
	BRA.S	calc_jump
; here we use 1 byte / pixel - can we use word shifts?
one_byte	LEA	btable,A2
	BTST	#16,D6		; is the origin odd?
	BEQ.S	calc_jump 	; yes, no word shift ->...
	BTST	#0,D5		; is step odd?
	BEQ.S	calc_jump 	; yes->...
	BTST	#0,D6		; is xsize odd?
	BEQ.S	calc_jump 	; yes->...
	LEA	wtable,A2
calc_jump LSL.W	#1,D2
	ADD.W	(A2,D2.W),A2
	JMP	(A2)

btable	dc.w	bleft-Btable
	dc.w	bright-btable
	dc.w	bup-btable
	dc.w	bdown-btable

wtable	dc.w	wleft-wtable
	dc.w	wright-wtable
	dc.w	wup-wtable
	dc.w	wdown-wtable

ltable	dc.w	lleft-ltable
	dc.w	lright-ltable
	dc.w	lup-ltable
	dc.w	ldown-ltable

; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%


; here, we do a left pan
wleft	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat
	CLR.L	D0
	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to x,y origin of "wdw" now

	MULU	D3,D5		; nbr of bytes needed for storage (step)
	MOVE.L	D5,D1		; keep
  

	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	SUBQ.W	#1,D7		; and prepare for DBF already

	CLR.W	D6
	SWAP	D6		; xsize% = nbr of pixels in "wdw"
	MULU	D3,D6		; nbr of bytes now
	SUB.W	D5,D6		; - step%
	LSR.W	#1,D6		; word sized moves
	SUBQ.W	#1,D6		; prepare for DBF

	LSR.W	#1,D5		; nbr of words
	SUBQ.W	#1,D5		; prepare for DBF
; here:
; D3 = nbr of bytes / pixel
; D4 = length of 1 line, in bytes
; D5 = nbr of words for storage -1
; D6 = nbr of words to shift -1
; D7 = nbr of lines to treat -1
	MOVE.L	A0,D3		; do we need to get mem?
	BNE.S	no_mem		; no ->...
	MOVEQ	#-1,D2		; it's for myself
	ADDQ.L	#8,D1		; just to make sure we won't overlap
get_mem	MOVEQ	#$18,D0		; MT_ALCHP
	TRAP	#$1		; get memory now
	TST.L	D0		; ok?
	BNE.S	pan_out		; NO! ->...
	CLR.L	D3
no_mem	MOVE.L	A5,A3		: point to first line now

; now deal with one line, A5 points to the 1rst byte of this line
line_lp	MOVE.W	D5,D0		; nbr of words -1 for mem buffer
	MOVE.L	A0,A1		; pointer to buffer
	MOVE.L	A3,A5
	MOVE.L	A5,A2		; keep pointer to start of line
cp1_lp	MOVE.W	(A5)+,(A1)+	; copy bytes to buffer
cp1_lp_do DBF	D0,cp1_lp
; here now, A5 points to the first pixel that must be panned LEFT
; when panning LEFT, the following bytes must be copied to here
	MOVE.W	D6,D0
cp2_lp	MOVE.W	(A5)+,(A2)+	; copy bytes, thus panning left
	DBF	D0,cp2_lp 	; at the end, A5 = start of next line!
	MOVE.L	A0,A1		; point to buffer
	MOVE.W	D5,D0		; nbr of words to copy

cp3_lp	MOVE.W	(A1)+,(A2)+
	DBF	D0,cp3_lp 	; copy buf frm start of line to end of line
	ADD.L	D4,A3		: point to next line
	DBF	D7,line_lp	; do for every line
	TST.L	D3
	BEQ.S	relmem
	MOVEQ	#0,D0
	RTS
relmem	MOVEQ	#$19,D0		; release mem now
	TRAP	#1
pan_out	RTS



; pan right
; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%


wright	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	SUBQ.W	#1,D7		; and prepare for DBF already
				         
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat
	CLR.L	D0
	MOVE.W	D6,D0		; xsize%
	SWAP	D6		; xsize% | xorig%
	ADD.W	D6,D0		; xorig% + xsize%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to pixel in "wdw" now

; calculate the nbr of bytes to shift in each line
	SWAP	D6
	SUB.W	D5,D6		; xsize%-step%
	MULU	D3,D6		; xsize%-step% in bytes
	LSR.W	#1,D6		; xsize%-step% in words
	SUBQ.W	#1,D6		; prepare for DBF

; calculate the step in bytes, (size of buffer needed)
	MULU	D3,D5		; nbr of bytes needed for storage (step)
	MOVE.L	D5,D1		; keep, also memory needed
	LSR.W	#1,D5		; step in words
	SUBQ.W	#1,D5		; for DBF
	MOVE.L	A0,D3
	BNE.S	liner_lp
; get mem for buffer
	ADDQ.L	#8,D1
	MOVEQ	#-1,D2		; it's for myself
	ADDQ.L	#8,D1		; just to make sure we won't overlap
	MOVEQ	#$18,D0		; MT_ALCHP
	TRAP	#$1		; get memory now
	TST.L	D0		; ok?
	BNE.S	pan_out		; NO! ->...
	CLR.L	D3
; now do each line
liner_lp	MOVE.L	A5,A2		; point to end of line
	MOVE.L	A0,A1		; point to start of buffer
	MOVE.W	D5,D0		; nbr of words in buffer
cp4_lp	MOVE.W	-(A2),(A1)+
	DBF	D0,cp4_lp 	; copy into buffer
	MOVE.L	A5,A1		; point end of line
	MOVE.W	D6,D0		; nbr of words to shift
cp5_lp	MOVE.W	-(A2),-(A1)
	DBF	D0,cp5_lp 	; copy rest of line
	MOVE.L	A0,A2		; point to buffer
	MOVE.W	D5,D0		; nbr of words in buffer
cp6_lp	MOVE.W	(A2)+,-(A1)
	DBF	D0,cp6_lp 	; get bytes back from buffer
	ADD.L	D4,A5		; point to (end of) next line
	DBF	D7,liner_lp	; do it for all lines
	TST.L	D3
	BEQ.S	relmem2
	MOVEQ	#0,D0
	RTS
relmem2	MOVEQ	#$19,D0		; release mem
	TRAP	#1
right_out RTS
; here we move up
; step% =nr of lines to scroll 32
; orig = X pixel where we start to scroll 100
; size% = nbr of X pixels to scroll 16

; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

wup	MOVE.L	A0,D2		; any mem there?
	BNE.S	nomem3
	MOVE.W	D5,D1		; step% = nbr of lines to scroll
	MULU	D6,D1		; * nbr of pixels to treat per line
	MULU	D3,D1		; nbr of bytes to store
	MOVE.L	D3,-(A7)
	ADDQ.L	#8,D1		; safety net
	MOVEQ	#$18,D0
	TRAP	#1		; get mem for this now
	MOVE.L	(A7)+,D3
	TST.L	D0
	BNE.S	right_out
	CLR.L	D2
nomem3	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	SUB.W	D5,D7		; minus step
	SUBQ.W	#1,D7		; and prepare for DBF already
				         
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat
	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to 1rst pixel in "wdw" now

	MOVE.L	A5,A3		; keep pointer to 1rst pixel of 1rst line
	SUBQ.W	#1,D5		; line counter
	SWAP	D6
	MULU	D3,D6		; nbr of bytes to treat per line
	LSR.W	#1,D6
	SUBQ.W	#1,D6		; pixel (word) counter
	MOVE.L	A0,A1		; point to buffer
	MOVE.W	D5,D3
line_lp1	MOVE.W	D6,D0
	MOVE.L	A3,A2
pix_lp	MOVE.W	(A2)+,(A1)+
	DBF	D0,pix_lp 	; copy bytes for 1 line
	ADD.L	D4,A3		; point to next line
	DBF	D3,line_lp1	; and do for all lines


; A3 now points to 1rst source , A5 to first target
line_lp2	MOVE.L	A5,A2		; point to target
	MOVE.L	A3,A1		; point to source
	MOVE.W	D6,D0		; nbr of words to copy per line -1
pix_lp2	MOVE.W	(A1)+,(A2)+
	DBF	D0,pix_lp2	; copy one line
	ADD.W	D4,A5		; point next target
	ADD.W	D4,A3		; point to next source
	DBF	D7,line_lp2	; at end, A5 = 1rst line to restore buffer to
	MOVE.L	A0,A1		; point to buffer
line_lp3	MOVE.W	D6,D0		; nbr of bytes to copy per line
	MOVE.L	A5,A2		; point to target
pix_lp3	MOVE.W	(A1)+,(A2)+
	DBF	D0,pix_lp3	; copy bytes for 1 line
	ADD.L	D4,A5		; point next line
	DBF	D5,line_lp3	; do for all lines
	TST.L	D2
	BEQ.S	up_out
	MOVEQ	#0,D0
	RTS
up_out	MOVEQ	#$19,D0
	TRAP	#1
up_o	RTS

; here we move down
; step% =nr of lines to scroll 32

; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = nbr of bytes per pixel
; D4 = length of 1 line, in bytes
; D5 = step%
; D6 = xorig% | xsize%
; D7 = yorig% | ysize%

wdown	MOVE.L	A0,D2		; any mem there?
	BNE.S	nomem4
	MOVE.W	D5,D1		; step% = nbr of lines to scroll
	MULU	D6,D1		; * nbr of pixels to treat per line
	MULU	D3,D1		; nbr of bytes to store
	MOVE.L	D3,-(A7)
	ADDQ.L	#8,D1		; safety net
	MOVEQ	#$18,D0
	TRAP	#1		; get mem for this now
	MOVE.L	(A7)+,D3
	TST.L	D0
	BNE.S	up_o
	CLR.L	D2
nomem4	SWAP	D7		; ysize% | yorig%
	MOVE.W	D7,D0		;
	SWAP	D7		; yorig% | ysize% (= nbr of lines to treat)
	ADD.W	D7,D0		; yorig%+ysize%
	SUB.W	D5,D7		; minus step
	SUBQ.W	#1,D7		; and prepare for DBF already

	SUB.W	D5,D0		, yorg%+ysize%-step%=1rst line to treat
	MULU	D4,D0		; offset to start line now
	ADD.L	D0,A5		; point to first screen line to treat

	SWAP	D6		; xsize% | xorig%
	MOVE.W	D6,D0		; xorig%
	MULU	D3,D0		; * nbr of bytes per pixel
	ADD.L	D0,A5		; point to 1rst pixel in 1rst line now

	MOVE.L	A5,A3		; keep pointer to 1rst pixel of 1rst line
	SUBQ.W	#1,D5		; line counter
	MOVE.W	D5,D1
	SWAP	D6
	MULU	D3,D6		; nbr of bytes to treat per line
	LSR.W	#1,D6
	SUBQ.W	#1,D6		; pixel (word) counter
	MOVE.L	A0,A1		; point to buffer
	MOVE.W	D5,D3
line_lp6	MOVE.W	D6,D0
	MOVE.L	A3,A2
pix_lp4	MOVE.W	(A2)+,(A1)+
	DBF	D0,pix_lp4	; copy bytes for 1 line
	ADD.L	D4,A3		; point to next line
	DBF	D3,line_lp6	; and do for all lines


; A3 now points to 1 line after 1rst target , A5 to 1 line after first source
	SUB.L	D4,A3
	SUB.L	D4,A5
line_lp5	MOVE.L	A3,A2		; point to target
	MOVE.L	A5,A1		; point to source
	MOVE.W	D6,D0		; nbr of words to copy per line -1
pix_lp5	MOVE.W	(A1)+,(A2)+
	DBF	D0,pix_lp5	; copy one line
	SUB.L	D4,A5		; point next target
	SUB.L	D4,A3		; point to next source
	DBF	D7,line_lp5	; at end, A5 = 1rst line to restore buffer to
	MULU	D4,D1
	SUB.L	D1,A3
	MOVE.L	A0,A1		; point to buffer
line_lp4	MOVE.W	D6,D0		; nbr of bytes to copy per line
	MOVE.L	A3,A2		; point to target
pix_lp6	MOVE.W	(A1)+,(A2)+
	DBF	D0,pix_lp6	; copy bytes for 1 line
	ADD.L	D4,A3		; point next line
	DBF	D5,line_lp4	; do for all lines
	TST.L	D2
	BEQ.S	down_out
	MOVEQ	#0,D0
	RTS
down_out	MOVEQ	#$19,D0
	TRAP	#1
	RTS

	end
