
******************************************************
* this rolls/pans/scrolls part of the screen
*
* NPAND_S xstep%, ystep%,xorig%,xsize%, yorig%,ysize%,direction% [,buffer [,fill_in]]
*
* where
*	step% = nbr of pixels to pan
*	xorig% = pixel to start at (from 0 to end of screen/line)
*	xsize% = nbr pixels to pan
*	yorig%,ysize% : same
*	direction% = roll/pan in what direction?
*		4 = upleft
*		5 = upright
*		6 = downleft
*		7 = downright
*	some memory to work with, or 0
*	fill_in = from where do you fill in the section if pan/scroll
*	  and not a roll?		NYI
*
*
* (c) W. Lenerz 2002
*
* v. 0.00  2002 Mar 03 09:28:18
******************************************************

	Section	npand_s
	xdef	npand_s

; parameters set up with setup_scr
	xref	scr_base		; base address of screen
	xref	scr_xsize 	; nbr of pixels (X)
	xref	scr_ysize
	xref	scr_llen		; length of 1 line in bytes
	xref	scr_bytes 	; nbr of bytes per pixel


; xrefs for the long word and byte sized shifts

	xref	dluleft
	xref	dluright
	xref	dldleft
	xref	dldright
	xref	dbuleft
	xref	dburight
	xref	dbdleft
	xref	dbdright


no_down	MOVEQ	#-19,D0		; not implemented (yet!)
pan_out	RTS
pan_errbp MOVEQ	#-15,D0
pan_out2	RTS
NPAND_S	MOVE.W	$118,A2
	JSR	(A2)		; get long integers
	TST.L	D0
	BNE	pan_out		; oops->...
	SUB.L	A0,A0		; show no mem parameter yet
	CMP.W	#9,D3		; all parameters?
	BNE.S	pan_get7		; no!->...
	MOVE.L	28(A6,A1.L),A4	; fill_in
	ADDQ.L	#4,$58(A6)
pan_get7	CMP.W	#8,D3
	BNE.S	pan_get6
	MOVE.L	32(A6,A1.L),A0	; buffer
	ADD.L	#32,$58(A6)
	BRA.S	got_valid
pan_get6	CMP.W	#7,D3		; all parameters?
	BNE.S	pan_errbp 	; no, so error! ->...
	ADD.L	#7*4,$58(A6)	; reset maths stack
got_valid CLR.L	D3
	CLR.L	D4
	CLR.L	D5
	MOVE.L	2(A6,A1.L),D5	; xstep%
	BEQ.S	pan_out2		; there is none, so we're finished (?)!
	MOVE.W	6(A6,A1.L),D5	; ystep%
	BEQ.S	pan_out2		; there is none, finished!
	MOVE.L	10(A6,A1.L),D6	 ; orig% into upper word
	MOVE.W	14(A6,A1.L),D6	; size% into lower wrd: xorig% | xsize%
	BEQ.S	pan_out2		; 0 size%? - we've finished ->...
	MOVE.L	18(A6,A1.L),D7	;
	MOVE.W	22(A6,A1.L),D7	; yorig% | ysize%
	BEQ.S	pan_out2		; oops! no y size?
	MOVE.L	scr_base(PC),A5	; screen base
	MOVE.W	scr_llen(PC),D4	; length of 1 line in bytes
	MOVE.W	scr_bytes(PC),D3	; nbr of bytes per pixel
	BEQ.S	pan_errbp 	; HUH?->...
	MOVE.L	24(A6,A1.L),D2	; direction switch
	SUBQ.W	#4,D2
	BMI.S	pan_errbp
	CMP.W	#3,D2
	BGT	no_down		; only allow 4-7
	LEA	ltable,A2 	; point to long words table
	CMP.W	#4,D3		; do we use 4 bytes / pixel?
	BEQ.S	calc_jump 	; yes, use this table directly
	CMP.W	#2,D3		; 2 or 1 byte/pixel?
	BNE.S	one_byte
; here we use 2 bytes/pixel - let's see whether we still can use Lword shifts

two_bytes LEA	wtable,A2 	; preset word table
	MOVE.L	D5,D0
	SWAP	D0		; xstep%
	BTST	#0,D0		; is step even?
	BNE.S	calc_jump 	; no ->...
	BTST	#0,D6		; is xsize even?
	BNE.S	calc_jump 	; no!->...
	LEA	ltable,A2 	; here we can use long word table
	BRA.S	calc_jump
one_byte	LEA	btable,A2
	BTST	#16,D6		; is the origin odd?
	BEQ.S	calc_jump 	; yes->...
	BTST	#0,D5		; is step odd?
	BEQ.S	calc_jump 	; yes->...
	BTST	#0,D6		; is xsize odd?
	BEQ.S	calc_jump 	; yes->...
	LEA	wtable,A2
calc_jump LSL.W	#1,D2
	ADD.W	(A2,D2.W),A2

	MOVE.L	A0,D2
	BNE.S	got_mem
	MOVE.W	D3,D0		; nbr bytes/pixel
	MULU	D6,D0		; * xsize%
	MULU	D5,D0		; * ystep%
	MOVE.W	D7,D1		; ysize%
	SUB.W	D5,D1		; -ystep%
	SWAP	D5		; ystep% | xstep%
	MULU	D3,D1		; * nbr bytes/pixel
	MULU	D5,D1		; * xstep%
	SWAP	D5
	ADD.L	D0,D1		; nbr of bytes needed
	ADDQ.L	#8,D1
	MOVEQ	#-1,D2
	MOVEQ	#$18,D0
	TRAP	#1
	TST.L	D0
	BNE.S	quit1
	CLR.L	D2
got_mem	MOVE.L	D7,D0
	SWAP	D0		; yorig%
	MULU	D4,D0		; point to line of wdw "orig"
	ADD.L	D0,A5
	MOVE.L	D6,D0
	SWAP	D0		; xorig%
	MULU	D3,D0
	ADD.L	D0,A5		; A5 points to "wdw" origin
	MOVE.W	D6,D0		; xsize%
	MULU	D3,D0		; in number of bytes now!
	MOVE.W	D7,D6		; D6 is now : yorig% | ysize%
	SWAP	D6		; ysize% | yorig%
	MOVE.W	D0,D6		; ysize% | xsize% in words (!)
	MOVE.L	D5,D1
	SWAP	D1
	MULU	D1,D3		; xstep in bytes
	SUB.W	D3,D0		; xsize% - xstep%
	MOVE.W	D0,-(A7)		; xsize%-xstep% in bytess
	SUB.W	D5,D7		; ysize% - ystep%
	MOVE.W	D7,-(A7)		; keep
	JMP	(A2)



btable	dc.w	dbuleft-btable
	dc.w	dburight-btable
	dc.w	dbdleft-btable
	dc.w	dbdright-btable
	
wtable	dc.w	dwuleft-wtable
	dc.w	dwuright-wtable
	dc.w	dwdleft-wtable
	dc.w	dwdright-wtable

ltable	dc.w	dluleft-ltable
	dc.w	dluright-ltable
	dc.w	dldleft-ltable
	dc.w	dldright-ltable



quit1	RTS
; rem pan up and left



; A0 = possible buffer mem
; A4 = where to fill in from (NYI)
; A5 = screen base
; D3 = xstep% in bytes
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = ysize% | xsize% in bytes



; now save the 1rst part of the screen (upper part) to the buffer
; we have to save the entire width of the window, ystep% lines deep.

dwuleft	LSR.W	#1,D6		; in words
	LSR.W	#1,D3		; in words
	MOVE.W	D6,D1		; xsize% in words
	SWAP	D6		; xsize% in words | ysize%
	SUBQ.W	#1,D1
	MOVE.L	A5,A1
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp1	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp1	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp1
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp1	; do for all lines in step
; now save the second part (left part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in words
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		;
	ADD.L	D0,A1		; point to start of what we need to save
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.L	A1,-(A7)
	MOVE.W	D3,D1		; xtep% in words
	SUBQ.W	#1,D1		; DBF
line_lp2	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp2	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp2
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp2	; do for all lines in "wdw" - step
; now copy each line up & left
	MOVE.L	(A7)+,A1		; wdw  orig (+ystep%)
	MOVE.W	(A7),D7		; the is the line counter: ysize-ystep
	SUBQ.W	#1,D7
	MOVE.W	D3,D0
;
	LSL.W	#1,D0		; xstep% in bytes
;
	ADD.W	D0,A1		; this is the start from where we copy
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytes
;
	LSR.W	#1,D1		; in words
;
	SUBQ.W	#1,D1		; nbr of pixels (words) to copy per line
	MOVE.L	A5,-(A7)		; keep
line_lp3	MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp3	MOVE.W	(A3)+,(A2)+	; copy words accross for one line
	DBF	D0,pix_lp3
	ADD.L	D4,A1		; point to next source line
	ADD.L	D4,A5		; point to next target line
	DBF	D7,line_lp3	; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	(A7),D0		; ysize%-ystep%
	MULU	D4,D0		; * nbr bytes per line
	ADD.L	D0,A1		; point to yorig% + ysize% -ystep% OK
	MOVE.W	2(A7),D0		; xsize% - xstep% in words
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in words
	SUBQ.W	#1,D1		; nbr of words to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#1,D5		; now in words
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = lower right, A3 = lower left
line_lp4	MOVE.L	A1,A2		; target line
	MOVE.W	D1,D0
pix_lp4	MOVE.W	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp4
	MOVE.W	D5,D0
	MOVE.L	A3,A2		; target line (lower left)
pix_lp5	MOVE.W	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp5
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp4
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in words)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%
; A3 now points to the first new screen data in buffer
	MOVE.W	2(A7),D0		; xsize%-xstep%
	ADD.W	D0,A5		; point to new xorigin
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
line_lp6	MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp6	MOVE.W	(A2)+,(A1)+
	DBF	D0,pix_lp6
	ADD.L	D4,A5
	DBF	D1,line_lp6
	CLR.L	D0
	TST.L	D2
	BNE.S	out1
	MOVEQ	#$19,D0
	TRAP	#1
out1	RTS


; now we're panning up right
; now save the 1rst part of the screen (upper part) to the buffer
; we have to save the entire width of the window, ystep% lines deep.
dwuright	LSR.W	#1,D6		; in words
	LSR.W	#1,D3		; in words
	MOVE.L	D6,D1		; xsize% in words
	SWAP	D6
	SUBQ.W	#1,D1
	MOVE.L	A5,A1
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp7	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp7	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp7
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp7	; do for all lines in step
; now save the second part (right part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in words
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		;
	ADD.L	D0,A1		; point to start of what we need to save
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.W	2(A7),D0		; xsize%-xstep% in bytes
	MOVE.L	A1,-(A7)		; keep
	ADD.W	D0,A1		; point to new x origin
	MOVE.W	D3,D1		; xtep% in words
	SUBQ.W	#1,D1		; DBF
line_lp8	MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp8	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp8
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp8	; do for all lines in "wdw" - step
; now copy each line up & right
	MOVE.L	(A7)+,A1		; wdw  orig (+ystep%)
	MOVE.W	(A7),D7		; line counter: ysize%-ystep%
	SUBQ.W	#1,D7
	MOVE.W	D3,D0
;
	LSL.W	#1,D0		; xstep% in bytes
;
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytess
;
	LSR.W	#1,D1		; now in words
;
	SUBQ.W	#1,D1		; nbr of pixels (words) to copy per line
	MOVE.L	A5,-(A7)		; keep
	ADD.W	D0,A5		; this is the start to where we copy
line_lp9	MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp9	MOVE.W	(A3)+,(A2)+	; copy words accross for one line
	DBF	D0,pix_lp9
	ADD.L	D4,A1		; point to next source line
	ADD.L	D4,A5		; point to next target line
	DBF	D7,line_lp9	; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	(A7),D0		; ysize%-ystep%
	MULU	D4,D0		; * nbr bytes per line
	ADD.L	D0,A1		; point to yorig% + ysize% -ystep% OK
	MOVE.W	2(A7),D0		; xsize% - xstep% in words
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in words
	SUBQ.W	#1,D1		; nbr of words to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#1,D5		; now in words
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = lower right, A3 = lower left
line_lp10 MOVE.L	A3,A2		; target line
	MOVE.W	D5,D0
pix_lp10	MOVE.W	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp10
	MOVE.W	D1,D0
	MOVE.L	A1,A2		; target line (lower left)
pix_lp11	MOVE.W	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp11
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp10
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in words)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%
; A3 now points to the first new screen data in buffer
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
line_lp12 MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp12	MOVE.W	(A2)+,(A1)+
	DBF	D0,pix_lp12
	ADD.L	D4,A5
	DBF	D1,line_lp12
	CLR.L	D0
	TST.L	D2
	BNE.S	out2
	MOVEQ	#$19,D0
	TRAP	#1
out2	RTS

; diagonal pan down left
dwdleft	LSR.W	#1,D6		; in words
	LSR.W	#1,D3		; in words
	MOVE.W	D6,D1		; xsize% in words
	SWAP	D6		; xsize% in words | ysize%
	SUBQ.W	#1,D1
	MOVE.L	A5,A1
	MOVE.W	(A7),D0
	MULU	D4,D0
	ADD.L	D0,A1		; point to origin of block to save
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp13 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp13	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp13
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp13	 ; do for all lines in step
; now save the second part (left part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in words
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.W	D3,D1		; xtep% in words
	SUBQ.W	#1,D1		; DBF
line_lp14 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp14	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp14
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp14	 ; do for all lines in "wdw" - step
; now copy each line down & left
	MOVE.W	(A7),D7		; the is the line counter: ysize-ystep
	SUBQ.W	#1,D7		; line counter
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytes
;
	LSR.W	#1,D1		; in words
;
	SUBQ.W	#1,D1		; nbr of pixels (words) to copy per line
	MOVE.L	A5,-(A7)		; keep
	MOVE.W	D6,D0
	SUBQ.W	#1,D0
	MULU	D4,D0
	ADD.L	D0,A5		; point to first target
	MOVE.L	A5,A1		; point wdw orig
	MOVE.W	D3,D0		; xstep% in words%
;
	LSL.W	#1,D0		; xstep% in bytes
;
	ADD.W	D0,A1		; this is the start from where we copy
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		: now in bytes
	SUB.L	D0,A1		; this is the source

line_lp15 MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp15	MOVE.W	(A3)+,(A2)+	; copy words accross for one line
	DBF	D0,pix_lp15
	SUB.L	D4,A1		; point to next source line
	SUB.L	D4,A5		; point to next target line
	DBF	D7,line_lp15	 ; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	2(A7),D0		; xsize% - xstep% in words
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in words
	SUBQ.W	#1,D1		; nbr of words to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#1,D5		; now in words
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = upper right, A3 = upper left
line_lp16 MOVE.L	A1,A2		; target line
	MOVE.W	D1,D0
pix_lp16	MOVE.W	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp16
	MOVE.W	D5,D0
	MOVE.L	A3,A2		; target line (lower left)
pix_lp17	MOVE.W	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp17
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp16
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in words)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%
; A3 now points to the first new screen data in buffer
	MOVE.W	2(A7),D0		; xsize%-xstep%
	ADD.W	D0,A5		; point to new xorigin
	MOVE.W	D5,D0
	MULU	D4,D0
	ADD.L	D0,A5
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
line_lp18 MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp18	MOVE.W	(A2)+,(A1)+
	DBF	D0,pix_lp18
	ADD.L	D4,A5
	DBF	D1,line_lp18
	CLR.L	D0
	TST.L	D2
	BNE.S	out3
	MOVEQ	#$19,D0
	TRAP	#1
out3	RTS


; now we're panning down right
; now save the 1rst part of the screen (upper part) to the buffer
; we have to save the entire width of the window, ystep% lines deep.
dwdright	LSR.W	#1,D6		; in words
	LSR.W	#1,D3		; in words
	MOVE.L	D6,D1		; xsize% in words
	SWAP	D6
	SUBQ.W	#1,D1
	MOVE.L	A5,A1

	MOVE.W	(A7),D0		; ysize% - ystep%
	MULU	D4,D0
	ADD.L	D0,A1		; point to origin of block to save
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.L	A0,A3
line_lp19 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp19	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp19
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp19	; do for all lines in step
; now save the second part (right part) of the "wdw" to the buffer
; we have to save xstep% bytes for ysze%-ystep% lines, starting at (0,ystep%)
; D3 = ???? | xstep% in words
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%

	MOVE.L	A5,A1		; "wdw" origin
	MOVE.W	2(A7),D0
	ADD.W	D0,A1
	MOVE.W	(A7),D7		; ysize% -ystep%
	SUBQ.W	#1,D7		; for DBF
	MOVE.W	D3,D1		; xtep% in words
	SUBQ.W	#1,D1		; DBF
line_lp20 MOVE.L	A1,A2
	MOVE.W	D1,D0
pix_lp20	MOVE.W	(A2)+,(A3)+	; copy words accross
	DBF	D0,pix_lp20
	ADD.L	D4,A1		; point to next line
	DBF	D7,line_lp20	 ; do for all lines in "wdw" - step
; now copy each line down & right
	MOVE.W	(A7),D7		; line counter: ysize%-ystep%
	SUBQ.W	#1,D7
	MOVE.W	D3,D0		; xstep% in words
;
	LSL.W	#1,D0		; xstep% in bytes
;
	MOVE.W	2(A7),D1		; xsize%-xstep% in bytes
;
	LSR.W	#1,D1		; now in words
;
	SUBQ.W	#1,D1		; nbr of pixels (words) to copy per line

	MOVE.L	A5,-(A7)		; keep
	MOVE.W	D6,D0
	SUBQ.W	#1,D0
	MULU	D4,D0
	ADD.L	D0,A5		; point to first target
	MOVE.L	A5,A1		; point wdw orig
	MOVE.W	D3,D0		; xstep% in words%
;
	LSL.W	#1,D0		; xstep% in bytes
;
	ADD.W	D0,A5		; this is the start to where we copy
	MOVE.W	D5,D0		; ystep%
	MULU	D4,D0		: now in bytes
	SUB.L	D0,A1		; this is the source
		

line_lp21 MOVE.L	A5,A2		; target
	MOVE.L	A1,A3		; source
	MOVE.W	D1,D0		; nbr of word to copy per line
pix_lp21	MOVE.W	(A3)+,(A2)+	; copy words accross for one line
	DBF	D0,pix_lp21
	SUB.L	D4,A1		; point to next source line
	SUB.L	D4,A5		; point to next target line
	DBF	D7,line_lp21	; do for all lines in "wdw" - step
; now copy back from the buffer
; first the part that was at the upper left corner and is now at the lower right corner
	MOVE.L	(A7)+,A5		; point to wdw "origin"
	MOVE.L	A5,A1		; same
	MOVE.W	2(A7),D0		; xsize% - xstep% in words
	MOVEM.L	D5/A5,-(A7)	; keep these

	MOVE.W	D3,D1		; xstep% in words
	SUBQ.W	#1,D1		; nbr of words to copy per line
			
	MOVE.W	D5,D7		; ystep%
	SUBQ.W	#1,D7		; prepare for DBF
	MOVE.W	D0,D5		, xsize%- xstep% in bytes
;
	LSR.W	#1,D5		; now in words
;
	SUBQ.W	#1,D5		; second counter (xsize%-xstep%)
	MOVE.L	A1,A3		; point to this origin now (lower left)
	ADD.W	D0,A1		; xorig of place where this goes (lower right)
	MOVE.L	A0,A5		; source
; a1 = lower right, A3 = lower left
line_lp22 MOVE.L	A3,A2		; target line
	MOVE.W	D5,D0
pix_lp22	MOVE.W	(A5)+,(A2)+	; copy source to target (lower right)
	DBF	D0,pix_lp22
	MOVE.W	D1,D0
	MOVE.L	A1,A2		; target line (lower left)
pix_lp23	MOVE.W	(A5)+,(A2)+	; now copy to lower left
	DBF	D0,pix_lp23
	ADD.L	D4,A3
	ADD.L	D4,A1
	DBF	D7,line_lp22
	MOVE.L	A5,A2		; keep pointer to source
	MOVEM.L	(A7)+,D5/A5
; D3 = ???? | xstep% (in words)
; D4 = length of 1 screen line, in bytes
; D5 = ???? | ystep%
; D6 = xsize% (in words) | ysize%
; A3 now points to the first new screen data in buffer
	SUBQ.W	#1,D3
	MOVE.W	(A7)+,D1		; ysize% - ystep%
	ADDQ.L	#2,A7
	SUBQ.W	#1,D1
	MULU	D4,D5
	ADD.L	D5,A5
line_lp24 MOVE.L	A5,A1		; point to target
	MOVE.W	D3,D0
pix_lp24	MOVE.W	(A2)+,(A1)+
	DBF	D0,pix_lp24
	ADD.L	D4,A5
	DBF	D1,line_lp24
	CLR.L	D0
	TST.L	D2
	BNE.S	out4
	MOVEQ	#$19,D0
	TRAP	#1
out4	RTS



	end
