************************************************************************
*
* PLOAD - loads screen into a screen save area as set up by the PE
*
* syntax:
*      PLOAD filename$,memptr
*      where:
*	filename$ = name of file
*	memptr = memory space pointer as returned by PSAVE
*
* (c) w. Lenrz 2002
* v. 1.00 2002 Mar 06 21:25:45
*************************************************************************


	section	pload
	XDEF	pload
	xref	scr_llen		; length of scren in bytes
	xref	scr_ysize

pload	ADDQ.L	#8,A3
	MOVE.W	$118,A2
	JSR	(A2)		; get the long int, mem ptr
	TST.L	D0
	BNE.S	L_out
	MOVE.L	(A6,A1.L),A4
	ADDQ.L	#4,$58(A6)
	MOVE.L	A3,A5
	SUBQ.L	#8,A3
	MOVE.W	$116,A2
	JSR	(A2)
	TST.L	D0
	BNE.S	l_out
	MOVE.W	(A6,A1.L),D0
	ADDQ.W	#3,D0
	BCLR	#0,D0
	ADD.L	D0,$58(A6)
	MOVE.L	A6,A0		; point to name....
	ADD.L	A1,A0		; ... now
	MOVEQ	#-1,D1
	MOVEQ	#1,D0
	MOVEQ	#1,D3
	TRAP	#2
	TST.L	D0		; open file
	BNE.S	l_out
	LEA	10(A4),A4
	MOVE.W	-4(A4),D7 	; length of 1 line
	MOVE.W	D7,D0
	MOVE.W	scr_llen(PC),D6
	SUB.W	D6,D0
	BMI.S	err_bp		; check that it doesn't exceed screen...
	MOVEQ	#-1,D3
	MOVE.W	scr_ysize(PC),D5
	SUBQ.W	#1,D5
line_lp	MOVE.L	A4,A1
	MOVE.W	D6,D2
	MOVEQ	#3,D0
	TRAP	#3
	TST.L	D0
	BNE.S	close	         ; screen area is longer than saved screen
	ADD.W	D7,A4
	DBF	D5,line_lp
close	MOVEQ	#2,D0
	TRAP	#2
l_out	RTS


err_bp	MOVEQ	#2,D0
	TRAP	#2
	MOVEQ	#-15,D0
	RTS


	end
